// NOTE : Below is a String I use to add to the data sent to the Nextion Display
//        And to verify the end of the string for incoming data.
//        Replace 3 x Serial2.write(0xff);
String  endChar = String(char(0xff)) + String(char(0xff)) + String(char(0xff));
String  dfd  = ""; // data from display
// NOTE : General Async Delay 
unsigned	long asyncDelay = 0;// NOTE : 4,294,967,295
int	delayLength = 1800;
// NOTE : Comment out the next two lines if using an Arduino with more than 1 serial port(MEGA)
#include <SoftwareSerial.h>
SoftwareSerial Serial2(2, 3); // RX, TX

// NOTE : MOTOR STUFF
//#include <Stepper.h>
//int motorRun = 0;// off = 0, on = 1
int motorClock = 8;
int motorDirection = 9;
int motorEnable = 10;// NOTE : ACTIVE LOW
int motorCounter = 1000;

void setup() {
  Serial.begin(9600);
  Serial2.begin(9600);
  Serial.println("STARTING UP...");
  pinMode(motorClock,OUTPUT);// NOTE : CLOCK
  pinMode(motorDirection,OUTPUT);// NOTE : DIRECTION
  pinMode(motorEnable,OUTPUT);// NOTE : RUN MOTOR
  digitalWrite(motorEnable,HIGH);// NOTE : START WITH MOTOR OFF
}

void loop() {
  // NOTE : COLLECT CHARACTERS FROM NEXTION DISPLAY
  if(Serial2.available()){
    inputFunction();
  }
  // NOTE : ASYNC DELAY
  // NOTE : CHANGED TO micros()
  // NOTE : faster micros might rollover to 0
  // NOTE : so lets check for that condition
  // NOTE : rollover occurs at 4,294,967,295
  if(micros() < delayLength){
    Serial.println("RESET OCCURED : micros = " + String(micros()) + " : asyncDelay = " + String(asyncDelay));
    asyncDelay = delayLength;
  }
  if(micros() > asyncDelay){
    asyncDelay+=(delayLength + (motorCounter*2));
    if(!digitalRead(motorEnable)){
      if(motorCounter > 0){
         motorCounter--;
      }
      digitalWrite(motorClock,!(digitalRead(motorClock)));
    }  
  }
}
